// This code was autogenerated with `dbus-codegen-rust --file third_party/NetworkManager/introspection/org.freedesktop.NetworkManager.Settings.xml -m None -c nonblock -o dbus_codegen/src/network_manager_settings.rs`, see https://github.com/diwic/dbus-rs
use dbus;
#[allow(unused_imports)]
use dbus::arg;
use dbus::nonblock;

pub trait OrgFreedesktopNetworkManagerSettings {
    fn list_connections(&self) -> nonblock::MethodReply<Vec<dbus::Path<'static>>>;
    fn get_connection_by_uuid(&self, uuid: &str) -> nonblock::MethodReply<dbus::Path<'static>>;
    fn add_connection(
        &self,
        connection: ::std::collections::HashMap<&str, arg::PropMap>,
    ) -> nonblock::MethodReply<dbus::Path<'static>>;
    fn add_connection_unsaved(
        &self,
        connection: ::std::collections::HashMap<&str, arg::PropMap>,
    ) -> nonblock::MethodReply<dbus::Path<'static>>;
    fn add_connection2(
        &self,
        settings: ::std::collections::HashMap<&str, arg::PropMap>,
        flags: u32,
        args: arg::PropMap,
    ) -> nonblock::MethodReply<(dbus::Path<'static>, arg::PropMap)>;
    fn load_connections(&self, filenames: Vec<&str>) -> nonblock::MethodReply<(bool, Vec<String>)>;
    fn reload_connections(&self) -> nonblock::MethodReply<bool>;
    fn save_hostname(&self, hostname: &str) -> nonblock::MethodReply<()>;
    fn connections(&self) -> nonblock::MethodReply<Vec<dbus::Path<'static>>>;
    fn hostname(&self) -> nonblock::MethodReply<String>;
    fn can_modify(&self) -> nonblock::MethodReply<bool>;
}

impl<'a, T: nonblock::NonblockReply, C: ::std::ops::Deref<Target = T>>
    OrgFreedesktopNetworkManagerSettings for nonblock::Proxy<'a, C>
{
    fn list_connections(&self) -> nonblock::MethodReply<Vec<dbus::Path<'static>>> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "ListConnections",
            (),
        )
        .and_then(|r: (Vec<dbus::Path<'static>>,)| Ok(r.0))
    }

    fn get_connection_by_uuid(&self, uuid: &str) -> nonblock::MethodReply<dbus::Path<'static>> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "GetConnectionByUuid",
            (uuid,),
        )
        .and_then(|r: (dbus::Path<'static>,)| Ok(r.0))
    }

    fn add_connection(
        &self,
        connection: ::std::collections::HashMap<&str, arg::PropMap>,
    ) -> nonblock::MethodReply<dbus::Path<'static>> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "AddConnection",
            (connection,),
        )
        .and_then(|r: (dbus::Path<'static>,)| Ok(r.0))
    }

    fn add_connection_unsaved(
        &self,
        connection: ::std::collections::HashMap<&str, arg::PropMap>,
    ) -> nonblock::MethodReply<dbus::Path<'static>> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "AddConnectionUnsaved",
            (connection,),
        )
        .and_then(|r: (dbus::Path<'static>,)| Ok(r.0))
    }

    fn add_connection2(
        &self,
        settings: ::std::collections::HashMap<&str, arg::PropMap>,
        flags: u32,
        args: arg::PropMap,
    ) -> nonblock::MethodReply<(dbus::Path<'static>, arg::PropMap)> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "AddConnection2",
            (settings, flags, args),
        )
    }

    fn load_connections(&self, filenames: Vec<&str>) -> nonblock::MethodReply<(bool, Vec<String>)> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "LoadConnections",
            (filenames,),
        )
    }

    fn reload_connections(&self) -> nonblock::MethodReply<bool> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "ReloadConnections",
            (),
        )
        .and_then(|r: (bool,)| Ok(r.0))
    }

    fn save_hostname(&self, hostname: &str) -> nonblock::MethodReply<()> {
        self.method_call(
            "org.freedesktop.NetworkManager.Settings",
            "SaveHostname",
            (hostname,),
        )
    }

    fn connections(&self) -> nonblock::MethodReply<Vec<dbus::Path<'static>>> {
        <Self as nonblock::stdintf::org_freedesktop_dbus::Properties>::get(
            &self,
            "org.freedesktop.NetworkManager.Settings",
            "Connections",
        )
    }

    fn hostname(&self) -> nonblock::MethodReply<String> {
        <Self as nonblock::stdintf::org_freedesktop_dbus::Properties>::get(
            &self,
            "org.freedesktop.NetworkManager.Settings",
            "Hostname",
        )
    }

    fn can_modify(&self) -> nonblock::MethodReply<bool> {
        <Self as nonblock::stdintf::org_freedesktop_dbus::Properties>::get(
            &self,
            "org.freedesktop.NetworkManager.Settings",
            "CanModify",
        )
    }
}

#[derive(Debug)]
pub struct OrgFreedesktopNetworkManagerSettingsNewConnection {
    pub connection: dbus::Path<'static>,
}

impl arg::AppendAll for OrgFreedesktopNetworkManagerSettingsNewConnection {
    fn append(&self, i: &mut arg::IterAppend) {
        arg::RefArg::append(&self.connection, i);
    }
}

impl arg::ReadAll for OrgFreedesktopNetworkManagerSettingsNewConnection {
    fn read(i: &mut arg::Iter) -> Result<Self, arg::TypeMismatchError> {
        Ok(OrgFreedesktopNetworkManagerSettingsNewConnection {
            connection: i.read()?,
        })
    }
}

impl dbus::message::SignalArgs for OrgFreedesktopNetworkManagerSettingsNewConnection {
    const NAME: &'static str = "NewConnection";
    const INTERFACE: &'static str = "org.freedesktop.NetworkManager.Settings";
}

#[derive(Debug)]
pub struct OrgFreedesktopNetworkManagerSettingsConnectionRemoved {
    pub connection: dbus::Path<'static>,
}

impl arg::AppendAll for OrgFreedesktopNetworkManagerSettingsConnectionRemoved {
    fn append(&self, i: &mut arg::IterAppend) {
        arg::RefArg::append(&self.connection, i);
    }
}

impl arg::ReadAll for OrgFreedesktopNetworkManagerSettingsConnectionRemoved {
    fn read(i: &mut arg::Iter) -> Result<Self, arg::TypeMismatchError> {
        Ok(OrgFreedesktopNetworkManagerSettingsConnectionRemoved {
            connection: i.read()?,
        })
    }
}

impl dbus::message::SignalArgs for OrgFreedesktopNetworkManagerSettingsConnectionRemoved {
    const NAME: &'static str = "ConnectionRemoved";
    const INTERFACE: &'static str = "org.freedesktop.NetworkManager.Settings";
}
