use dbus::Path;

pub struct ConnectionWrapper<'a> {
    path: Path<'a>,
}

impl<'a> ConnectionWrapper<'a> {
    pub async fn from_path<P>(path: P) -> ConnectionWrapper<'a>
    where
        P: Into<dbus::Path<'a>>,
    {
        let path = path.into();

        ConnectionWrapper { path }
    }

    pub fn get_path(&self) -> Path<'a> {
        self.path.clone()
    }
}
